﻿init python:
    import pygame
    import random
    import time
    random.seed(time.perf_counter_ns())
    def distance(a, b):
        if a >= b:
            result = a - b
        else:
            result = b - a
        return result
    class cosmic_orbs(renpy.Displayable):
        def __init__(self, name, image):
            super(renpy.Displayable,self).__init__()
            self.name = name
            self.image = image
            self.x = 160
            self.y = 500
            self.visible = True
            self.parent = None
        def render(self,width,height,st,at):
            if self.visible:
                self.y += -4
                if self.y < -410:
                    self.visible = False
                for i in self.parent.floating:
                    if distance(self.y, i.y) < 30:
                        if distance(self.x, i.x) < 40:
                            self.visible = False
                            i.y_velocity -= 1
                            break

                t = Transform(self.image, xanchor=0.5, yanchor=0.5, zoom = 2)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x, self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0, 0)
        
    class cosmic_creature(renpy.Displayable):
        def __init__(self, name, image):
            super(renpy.Displayable,self).__init__()
            self.name = name
            self.image = image
            self.x = random.randint(-20,20)
            self.y = random.randint(-20,20)
            self.x_velocity = random.randint(-3,3)
            self.y_velocity = random.randint(-3,3)
            self.visible = True
            self.parent = None
            self.clicked = False

        def render(self,width,height,st,at):
            if self.visible:
                if not self.clicked:
                    self.x += self.x_velocity
                    self.y += self.y_velocity
                    if abs(self.x) > 220:
                        self.x_velocity = -self.x_velocity
                    if self.y < -420 or self.y > 120:
                        self.y_velocity = -self.y_velocity
 
                t = Transform(self.image, xanchor=0.5, yanchor=0.5, zoom = 2)
                child_render = renpy.render(t, width, height, st, at)
                cw, ch = child_render.get_size()

                rv = renpy.Render(cw, ch)
                rv.blit(child_render, (self.x, self.y))

                renpy.redraw(self, 0)
                return rv
            else:
                return renpy.Render(0, 0)
        def click(self):
            self.clicked = True
        def pay(self):
            if self.visible:
                # self.parent.count += 1
                self.parent.points += self.points
                floating_text(self.points, self.x, self.y)

    class cosmic_manager:
        def __init__(self, creatures):
            self.creatures = creatures
            self.orbs = ["cosmic_orbstar", "cosmic_color_orb", "cosmic_swap_orb"]
            self.selected = self.orbs[0]
            self.floating = []
            self.shot_orbs = []
        def shoot(self):
            for i in self.shot_orbs:
                if not i.visible:
                    self.shot_orbs.remove(i)
            m = renpy.get_mouse_pos()
            o = self.selected
            orb = cosmic_orbs(o,o)
            orb.x, orb.y = m[0] - 960, m[1] - 540
            orb.parent = self
            self.shot_orbs.append(orb)
        def spawn(self):
            for i in self.floating:
                if not i.visible:
                    self.floating.remove(i)
            if len(self.floating) < 5:
                c = random.choice(self.creatures)
                creature = cosmic_creature(c,c)
                self.floating.append(creature)
        def select(self, orb):
            self.selected = orb
screen cosmic_screen(g):
    modal True
    timer 1 repeat True action Function(g.spawn)
    frame xysize 500,900:
        background "#000408" align .5,.5
        button:
            xysize 500,220 align .5,1.0 background Frame("cosmic_frame", 15,15) yoffset -64
            action Function(g.shoot)
        hbox:
            align .5,1.0
            for i in g.orbs:
                button:
                    padding 0,0
                    selected_foreground Frame("cosmic_frame", 15,15)
                    hover_foreground Frame("cosmic_frame", 15,15)
                    add i at zoom(2, True)
                    action Function(g.select, i), SelectedIf(g.selected == i)
    for i in g.floating:
        add i align .5,.5
    for i in g.shot_orbs:
        add i align .5,.5


    # vbox:
    #     text str(len(g.shot_orbs))
    #     text g.selected
init:
    image cosmic_kittopie = Crop((0,0,32,32), "cosmic/sprites.png")
    image cosmic_musoflex = Crop((32,0,32,32), "cosmic/sprites.png")
    image cosmic_luppo = Crop((64,0,32,32), "cosmic/sprites.png")
    image cosmic_frater = Crop((96,0,32,32), "cosmic/sprites.png")

    image cosmic_orbstar = Crop((0,32,32,32), "cosmic/sprites.png")
    image cosmic_color_orb = Crop((32,32,32,32), "cosmic/sprites.png")
    image cosmic_swap_orb = Crop((64,32,32,32), "cosmic/sprites.png")
    image cosmic_frame = Crop((0,96,32,32), "cosmic/sprites.png")
    

default my_creations = cosmic_manager(
    creatures = [
        "cosmic_kittopie",
        "cosmic_musoflex",
        "cosmic_luppo",
        "cosmic_frater",
    ]
)
label cosmic_example:
    call screen cosmic_screen(my_creations)

